VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "OSStamp"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

'================================================
'    OSVERSIONINFO
'------------------------------------------------
'Credits:

'How to change time zone information by using
'Visual Basic
'http://support.microsoft.com/kb/221542
'Article ID     :       221542

'How to determine which 32-bit Windows version is being used
'http://support.microsoft.com/kb/q189249/


'MSDN/System Information Structures/OSVERSIONINFO
'http://msdn.microsoft.com/library/default.asp?url=/library/en-us/sysinfo/base/osversioninfoex_str.asp


'http://www.developerfusion.co.uk/show/1643/
'------------------------------------------------


'------------------------------------------------
'Reference:
'VBnet, Randy Birch.
'http://vbnet.mvps.org/index.html?code/system/getversionex.htm
'------------------------------------------------


'typedef struct _OSVERSIONINFO {
'  DWORD dwOSVersionInfoSize;
'  DWORD dwMajorVersion;
'  DWORD dwMinorVersion;
'  DWORD dwBuildNumber;
'  DWORD dwPlatformId;
'  TCHAR szCSDVersion[128];
'} OSVERSIONINFO;


'typedef struct _OSVERSIONINFOEX {
     'has all elements from above structure:
'  DWORD dwOSVersionInfoSize;
'  DWORD dwMajorVersion;
'  DWORD dwMinorVersion;
'  DWORD dwBuildNumber;
'  DWORD dwPlatformId;
'  TCHAR szCSDVersion[128];
     
     'plus following elements:
     '  WORD wServicePackMajor;
     '  WORD wServicePackMinor;
     '  WORD wSuiteMask;
     '  BYTE wProductType;
     '  BYTE wReserved;
'}


'================================================
'GetVersionEx
'------------------------------------------------
'Retrieves information about the current
'operating system.
'BOOL GetVersionEx(
'  LPOSVERSIONINFO lpVersionInfo
');
Private Declare Function GetVersionEx Lib _
        "Kernel32" _
Alias "GetVersionExA" (lpVersionInformation _
      As VB_OSVERSIONINFOEX) As Long


Private Declare Function GetVersionNotEx Lib _
        "Kernel32" _
Alias "GetVersionExA" (lpVersionInformation _
      As VB_OSVERSIONINFO) As Long
'================================================

'Not used in this project:
'Private Const VER_PLATFORM_WIN32_NT = 2
'The operating system is Windows Vista,
'Windows Server "Longhorn",
'Windows Server 2003,
'Windows XP, Windows 2000,
'or Windows NT.


'Not used in this project:
'Private Const VER_PLATFORM_WIN32_WINDOWS = 1
'The operating system is Windows Me,
'Windows 98, or Windows 95.


Private Type VB_OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128 'Aux. String.
End Type


Private Type VB_OSVERSIONINFOEX
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128 'Aux. String.
          wServicePackMajor As Integer
          wServicePackMinor As Integer
          wSuiteMask As Integer
          wProductType As Byte
          wReserved As Byte
End Type

Private OSVer As VB_OSVERSIONINFO
Private OSVerEx As VB_OSVERSIONINFOEX


Private ProductType$(3)

'Version numbers and titles:
Private m_Title$(50), VerNumber$(50)
Private SuiteMask&(50), SuiteMaskDesc$(50), _
        SuiteMaskLim&


'Results are collected here:
Private Xc$  'Exception text if cannot work.
Private BuildNo 'Windows Build Number.
Private CSDVersion$

Private ExpandedStructureWorks& '1 yes, 0 no.
Private SPMajor&, SPMinor&

Private OSIx&  'Unofficial internal index.


'Unofficial internal index constants:
Private Const WinUnknown As Long = 13

Private Const Win95 As Long = 0
Private Const Win98 As Long = 1
Private Const WinMe As Long = 2
Private Const WinNT40 As Long = 3
Private Const WinSer2003R2 As Long = 4
Private Const WinSer2003 As Long = 5
Private Const WinXP As Long = 6
Private Const Win2000 As Long = 7

Private Const WinVista As Long = 8
Private Const WinSerLonghorn As Long = 9
Private Const WinXPProf64 As Long = 10
Private Const WinNT3_51 As Long = 11

Private Const WinVistaOrLonghorn As Long = 12

Private Const WinXPProfessional As Long = 14
Private Const WinXPHomeEdition As Long = 15
Private Const Win2000Professional As Long = 16
Private Const WinNTWorkstation As Long = 17

Private Const WinSer2003OrWinSer2003R2_or_XP64 _
              As Long = 18
Private Const WinXPHome As Long = 19

'------------------------------------------------
'    OSVERSIONINFO
'================================================


'Obsolete method:
Private Declare Function GetVersion Lib "Kernel32" () As Long

'================================================
'    Computer Name
'------------------------------------------------
'BOOL GetComputerName(
'  LPTSTR lpBuffer,
'  LPDWORD lpnSize
');
Private Declare Function GetComputerName Lib "Kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long



Public Function ComputerName$()

Dim s$, sz&

sz = 1000 'Shoud be enough for todays computers.

s = String(sz, 0)
If GetComputerName(s, sz) = 0 Then '29) = 0 Then
   ComputerName = "Unknown. Cannot estimate."
Else
   ComputerName = cs2vbs(s, "")
End If

End Function
Public Sub FindOSVersion()

Dim n&
'loCal variables:
Dim loPlatform&, loMajor&, loMinor&, loAux$

Xc = ""  'No error
OSIx = WinUnknown

On Error GoTo XH

'First try expanded version structure:
OSVerEx.dwOSVersionInfoSize = Len(OSVerEx)
ExpandedStructureWorks = GetVersionEx(OSVerEx)
If ExpandedStructureWorks Then

   loPlatform = OSVerEx.dwPlatformId
   loMajor = OSVerEx.dwMajorVersion
   loMinor = OSVerEx.dwMinorVersion
   BuildNo = OSVerEx.dwBuildNumber
   loAux = Trim(cs2vbs(OSVerEx.szCSDVersion, ""))
   
   'Expanded info.
   SPMajor = OSVerEx.wServicePackMajor
   SPMinor = OSVerEx.wServicePackMinor

Else

   OSVer.dwOSVersionInfoSize = Len(OSVer)
   n = GetVersionNotEx(OSVer)
   If Not CBool(n) Then
      Xc = "Cannot Retrieve Windows Version"
      Exit Sub
   End If
   loPlatform = OSVer.dwPlatformId
   loMajor = OSVer.dwMajorVersion
   loMinor = OSVer.dwMinorVersion
   BuildNo = OSVer.dwBuildNumber
   loAux = Trim(cs2vbs(OSVer.szCSDVersion, ""))
   
End If


Select Case loPlatform

Case 1:   'Win. 95 Platform
   If loMajor <> 4 Then
      'They all have major version 4.
      Xc = "Unknown Major Version " & _
           loMajor & _
           " in Windows Platform 1."
      OSIx = WinUnknown
      Exit Sub
   End If
   
   Select Case loMinor
   Case 10: OSIx = Win98
            'The operating system is Windows 98.
   Case 90: OSIx = WinMe 'Windows ME
   Case 0:  OSIx = Win95 'Windows 95
   End Select




Case 2   'PLATFORM WIN32 NT
         
   Select Case loMajor
   Case 3: OSIx = WinNT3_51
   Case 4: OSIx = WinNT40
   Case 5:
           Select Case loMinor
           Case 0:     OSIx = Win2000
           Case 1:     OSIx = WinXP
           Case 2:     OSIx = _
           WinSer2003OrWinSer2003R2_or_XP64
           Case Else:
                OSIx = WinUnknown
                Xc = "Undefined Minor Version"
           End Select
   Case 6: OSIx = WinVistaOrLonghorn
   End Select
   
Case Else
   Xc = "Unknown Windows Platform " & loPlatform
   OSIx = WinUnknown
   
End Select


'szCSDVersion
'    A null-terminated string.
'    For example: "Service Pack 2".
'    This string indicates
'    the recently installed Service Pack.
'    Empty string indicates that
'    no Pack installed.
'
'        Windows Me/98/95:
'           Pointer to a null-terminated
'           string. This string refers to
'           additional version information.
'           "A" or "B" denotes
'           Windows 98 Second Edition.
'           "C" denotes Windows 95 OSR2.
CSDVersion = loAux
If Win98 = OSIx Then
   Select Case CSDVersion
   Case "A", "B"
      CSDVersion = CSDVersion & " = " & _
                   "Windows 98 Second Edition"
   End Select
ElseIf Win95 = OSIx Then
   Select Case CSDVersion
   Case "C"
      CSDVersion = CSDVersion & " = " & _
                   "Windows 95 OSR2"
   End Select
End If



'kk.start here
'Additional
If ExpandedStructureWorks Then
   Select Case OSIx
   Case WinXP
        If OSVerEx.wSuiteMask And &H200 Then
           OSIx = WinXPHome
        End If
   End Select
End If
Exit Sub


XH:  Xc = "Error " & Err.Number & " " & _
          Err.Description
     Exit Sub

End Sub
'DESC Obsolete.
'
Public Function FindWinVersion$( _
                LowVersionByte&, _
                UpperVersionByte&, _
                FullVersion&)

Dim VersionSign&, i&, n&

i = GetVersion()
VersionSign = i And &H80000000
n = i And &H7FFF0000
FullVersion = n / &H10000
If VersionSign <> 0 Then
   FullVersion = FullVersion + 32768 '&H8000
End If

'Does not work:
'FullVersion = GetVersion() And &HFFFF0000) / _
               &H10000

UpperVersionByte = _
             (FullVersion And &HFF00) / &H100
LowVersionByte = (FullVersion And &HFF)
FindWinVersion = CStr(UpperVersionByte) & _
                      "." & LowVersionByte

End Function




Public Function FullTitle$()

Dim s$, ss$, n&, loFullVerNumber&

If Len(Xc) <> 0 Then
   s = Xc
Else
   s = m_Title(OSIx)
End If

l2s s, "Version Number   = " & _
       VerNumber(OSIx) & "." & _
       CStr(BuildNo And &HFFFF&)
l2s s, "Full Build Number= " & BuildNo
l2s s, "Lowest 4 Bytes of Build Number = " & _
       CStr(BuildNo And &HFFFF&) & _
       " as in MyComputer/Properties."

If Len(CSDVersion) > 0 Then
   l2s s, "Service Pack     = " & CSDVersion
Else
   l2s s, " No Service Pack installed."
End If

'Expanded info:
If ExpandedStructureWorks Then '1 yes, 0 no.
   l2s s, "SP Major.Minor   = " & _
          SPMajor & "." & SPMinor
   n = OSVerEx.wProductType
   If n < 1 Or n > 3 Then
      l2s Xc, "Unknown ""Product Type"" = " & n
   Else
      l2s s, "ProductType      = " & _
             ProductType(n)
   End If
   For n = 0 To SuiteMaskLim
       If OSVerEx.wSuiteMask And SuiteMask(n) _
          Then
          l2s s, SuiteMaskDesc(n)
       End If
   Next
End If

FullTitle = s

End Function

Public Function ShortTitile$()

If Len(m_Title(OSIx)) <> 0 Then
   ShortTitile = m_Title(OSIx) & " (" & _
       VerNumber(OSIx) & "." & _
       CStr(BuildNo And &HFFFF&) & ")"
ElseIf Len(Xc) <> 0 Then
   ShortTitile = Xc
Else
   ShortTitile = "Unknow Version"
End If

End Function


Private Sub Class_Initialize()

m_Title(WinUnknown) = "Unknown. Cannot Define."
VerNumber(WinUnknown) = "??.??"

m_Title(WinSerLonghorn) = "Windows Server ""Longhorn"""
VerNumber(WinSerLonghorn) = "6.0"

m_Title(WinVista) = "Windows Vista"
VerNumber(WinVista) = "6.0"

m_Title(WinSer2003R2) = "Windows Server 2003 R2"
VerNumber(WinSer2003R2) = "5.2"

m_Title(WinSer2003) = "Windows Server 2003"
VerNumber(WinSer2003) = "5.2"

m_Title(WinXP) = "Windows XP"
VerNumber(WinXP) = "5.1"

m_Title(WinXPHome) = "Windows XP Home Edition"
VerNumber(WinXPHome) = "5.1"

m_Title(Win2000) = "Windows 2000"
VerNumber(Win2000) = "5.0"

m_Title(WinMe) = "Windows Me"
VerNumber(WinMe) = "4.90"

m_Title(Win98) = "Windows 98"
VerNumber(Win98) = "4.10"

m_Title(WinNT40) = "Windows NT 4.0"
VerNumber(WinNT40) = "4.0"

m_Title(Win95) = "Windows 95"
VerNumber(Win95) = "4.0"

m_Title(WinNT3_51) = "Windows NT 3.51"
VerNumber(WinNT3_51) = "3.51"

m_Title(WinVistaOrLonghorn) = _
        "Windows Vista Or Longhorn"
VerNumber(WinVistaOrLonghorn) = "6.0"

m_Title(WinSer2003OrWinSer2003R2_or_XP64) = _
   "Windows Server 2003 Or Server 2003 R2 or XP Prof. 64"
VerNumber(WinSer2003OrWinSer2003R2_or_XP64) = "5.2"


'================================================
'wProductType
'------------------------------------------------

'VER_NT_WORKSTATION
' Meaning:
'   OS is Windows Vista,
'   Windows XP Professional,
'   Windows XP Home Edition,
'   Windows 2000 Professional,
'   Windows NT Workstation 4.0.
ProductType(1) = "Windows NT Workstation"

'VER_NT_DOMAIN_CONTROLLER
ProductType(2) = "Windows NT Domain Controller"
'VER_NT_SERVER
ProductType(3) = "Windows NT Server, Not Domain Controller."
'================================================



'================================================
'wSuiteMask
   'A bit mask for product suites on the system.
   'Combination of the following values.
'------------------------------------------------

'do1: &H = 0x
SuiteMask(0) = &H4  'VER_SUITE_BACKOFFICE
SuiteMaskDesc(0) = "SUITE_BACKOFFICE = Microsoft BackOffice components are installed."

SuiteMask(1) = &H400 'VER_SUITE_BLADE
SuiteMaskDesc(1) = "SUITE_BLADE      = Windows Server 2003, Web Edition is installed."

SuiteMask(2) = &H4000 'VER_SUITE_COMPUTE_SERVER
SuiteMaskDesc(2) = "SUITE_COMPUTE_SERVER = Windows Server 2003, Compute Cluster Edition is installed."


SuiteMask(3) = &H80 'VER_SUITE_DATACENTER
SuiteMaskDesc(3) = "VER_SUITE_DATACENTER = Datacenter Edition of Windows Server ""Longhorn"" or of Windows Server 2003, or Windows 2000 Datacenter Server."

SuiteMask(4) = &H2 'VER_SUITE_ENTERPRISE
SuiteMaskDesc(4) = "SUITE_ENTERPRISE = Windows Server ""Longhorn"", Enterprise Edition, Windows Server 2003, Enterprise Edition, Windows 2000 Advanced Server, or Windows NT Server 4.0 Enterprise Edition is installed."
                   '"Remarks section should have more info."

SuiteMask(5) = &H40 'VER_SUITE_EMBEDDEDNT
SuiteMaskDesc(5) = "SUITE_EMBEDDEDNT = Windows XP Embedded is installed."

SuiteMask(6) = &H200 'VER_SUITE_PERSONAL
SuiteMaskDesc(6) = "SUITE_PERSONAL   = Windows Vista Home Premium, Windows Vista Home Basic, or Windows XP Home Edition is installed."

SuiteMask(7) = &H100 'VER_SUITE_SINGLEUSERTS
SuiteMaskDesc(7) = "SUITE_SINGLEUSERTS = Remote Desktop is supported. Only one interactive session. " & _
                   "Set unless the system is in application server mode."

SuiteMask(8) = &H1 'VER_SUITE_SMALLBUSINESS
SuiteMaskDesc(8) = "SUITE_SMALLBUSINESS = Microsoft Small Business Server was once installed on the system, but may have been upgraded to another version of Windows."
                   'Refer to the Remarks section should have more

SuiteMask(9) = &H20 'VER_SUITE_SMALLBUSINESS_RESTRICTED
SuiteMaskDesc(9) = "SUITE_SMALLBUSINESS_RESTRICTED = Microsoft Small Business Server is installed with the restrictive client license in force."
                   'Refer to the Remarks section should have more

SuiteMask(10) = &H2000 'VER_SUITE_STORAGE_SERVER
SuiteMaskDesc(10) = "SUITE_STORAGE_SERVER = Windows Storage Server 2003 R2 or Windows Storage Server 2003 is installed."

SuiteMask(11) = &H10 'VER_SUITE_TERMINAL
SuiteMaskDesc(11) = "SUITE_TERMINAL = Terminal Services is installed. Always set."
                     'If VER_SUITE_TERMINAL but
                     'VER_SUITE_SINGLEUSERTS is not,
                     'then the system is in application server mode.

SuiteMaskLim = 11


FindOSVersion

End Sub


